unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,mmsystem, Menus, dspack, OleServer, ComCtrls, directshow,DSUtil;

type
  TForm3 = class(TForm)
    PopupMenu1: TPopupMenu;
    FullScreen1: TMenuItem;
    Timer1: TTimer;
    VideoWindow: TDSVideoWindow;
    TrackBar: TDSTrackBar;
    FilterGraph: TDSFilterGraph2;
    Options1: TMenuItem;
    DVDGraph: TDSDVDGraph;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FullScreen1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure VideoWindowDblClick(Sender: TObject);
    procedure VideoWindowMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure VideoWindowMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FilterGraphGraphComplete(sender: TComponent; Result: HRESULT;
      Renderer: IBaseFilter);
    procedure FormCreate(Sender: TObject);
    procedure VideoWindowMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DVDGraphGraphComplete(sender: TComponent; Result: HRESULT;
      Renderer: IBaseFilter);
    procedure DVDGraphDVDCurrentHMSFTime(sender: TComponent;
      HMSFTimeCode: TDVD_HMSF_TIMECODE; TimeCode: TDVD_TimeCode);
  private
    { Private declarations }
  public
    procedure GetFilter(graph: IFilterGraph);
  published
    procedure PopupMenuItemsClick(Sender: TObject);
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   mode:=_stop;
   form1.time.Caption:='00:00';
   form3.FilterGraph.MediaControl.stop;
   form3.DVDGraph.MediaControl.Stop;
end;

procedure TForm3.FullScreen1Click(Sender: TObject);
begin
 if Form3.WindowState = wsMaximized then
   begin
      popupmenu1.Items[0].Caption:='Full Screen Mode';
      Form3.WindowState := wsNormal
   end
 else
   begin
      popupmenu1.Items[0].Caption:='Window Mode';
      Form3.WindowState := wsMaximized;
   end;
end;

procedure TForm3.Timer1Timer(Sender: TObject);
begin
   if form3.WindowState=wsMaximized then form3.Cursor:=crNone;
end;

procedure TForm3.VideoWindowDblClick(Sender: TObject);
begin
   form1.SetFocus;
end;

procedure TForm3.VideoWindowMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  form3.Cursor:=crDefault;
  if (ssleft in shift) and (form3.WindowState<>wsMaximized) then
  begin
    form3.Left:=form3.Left-mouse_point.X+x;
    form3.top:=form3.top-mouse_point.y+y;
  end
  else
  if assigned(DVDGraph.DvdControl2) then
  begin
    mouse_point.x := x;
    mouse_point.y := y;
    DVDGraph.DvdControl2.SelectAtPosition(mouse_point);
  end;
end;

procedure TForm3.VideoWindowMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  mouse_point.X:=x;
  mouse_point.Y:=y;
end;

procedure TForm3.FilterGraphGraphComplete(sender: TComponent;
  Result: HRESULT; Renderer: IBaseFilter);
begin
 form1.nextclick(sender)
end;

procedure TForm3.GetFilter(graph: IFilterGraph);
var EnumFilters: IEnumFilters;
    BaseFilter: IBaseFilter;
    FilterInfo: TFilterInfo;
    menu:TMenuItem;
    x:integer;
begin
  x:=0;
  form3.PopupMenu1.Items[1].Clear;
  graph.EnumFilters(EnumFilters);
  While (EnumFilters.Next(1, BaseFilter, nil)=S_OK) do
  begin
    BaseFilter.QueryFilterInfo(FilterInfo);
    menu:=tmenuitem.Create(popupmenu1.Items[1]);
    form3.PopupMenu1.Items[1].Add(menu);
    menu.Caption:=FilterInfo.achName;
    menu.OnClick := PopupMenuItemsClick;// assign it an event
    menu.Tag:=x;
    x:=x+1;
  end;
  if x>0 then form3.PopupMenu1.Items[1].Delete(x-1);
end;

procedure TForm3.PopupMenuItemsClick(Sender: TObject);
var BaseFilter: IBaseFilter;
begin
  with Sender as TMenuItem do
  FilterGraph.FilterGraph2.FindFilterByName(StringToOleStr(caption), BaseFilter);
  ShowFilterPropertyPage(form3,BaseFilter);
  BaseFilter := nil;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
   form3.Top:=form1.Top;
   form3.Left:=form1.left-form3.Width;
end;

procedure TForm3.VideoWindowMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if assigned(DVDGraph.DvdControl2) then
  begin
    mouse_point.x := x;
    mouse_point.y := y;
    DVDGraph.DvdControl2.ActivateAtPosition(mouse_point);
  end;
end;

procedure TForm3.DVDGraphGraphComplete(sender: TComponent; Result: HRESULT;
  Renderer: IBaseFilter);
begin
   form1.nextclick(sender)
end;

procedure TForm3.DVDGraphDVDCurrentHMSFTime(sender: TComponent;
  HMSFTimeCode: TDVD_HMSF_TIMECODE; TimeCode: TDVD_TimeCode);
var hm:integer;
    str:string;
    x:integer;
    tim:TDVD_HMSF_TIMECODE;
    FLAG:ULONG;

begin
    if HMSFTimeCode.bSeconds<10 then str:='0' else str:='';
    form1.time.Caption:=str+inttostr(HMSFTimeCode.bSeconds);
    hm:=HMSFTimeCode.bHours*60+HMSFTimeCode.bMinutes;
    if hm<10 then str:='0' else str:='';
    form1.time.Caption:=str+inttostr(hm)+':'+form1.time.Caption;
//    form1.rnd.Caption:=inttostr(random(100));
    // 
    dvdgraph.DvdInfo2.GetTotalTitleTime(tim,FLAG);
    x:=Tim.bHours*3600+Tim.bMinutes*60+tim.bSeconds;
    unit1.cur_track_len:=x;
    unit1.cur_pos:=hm*60+HMSFTimeCode.bSeconds;
end;

end.
